<template>
  <div class="relative box-border mt-4">
    <MKSpinnerAnimation v-if="!creditCardLoaded" />
    <div
      v-show="creditCardLoaded"
      id="mkstripeinput-2"
      class="cell mk-cc-input input-elements border-b md:border-grey-20 lg:border-grey-20"
      variant="outline"
    >
      <div class="fields cc-fields">
        <div id="s-cc-card-icon">
          <img
            class="w-10 h-6 icon-margin"
            :src="require('~/assets/images/' + CARD_ICON)"
            alt=""
          />
        </div>
        <div class="field cc-field-number w-2/4 md:w-2/4 pr-4">
          <div id="s-cc-card-number" class="input empty pl-2"></div>
          <label for="s-cc-card-number" class="s-cc-labels number-left mb-1"
            >Card number</label
          >
        </div>
        <div class="field cc-field-item w-16 md:w-1/6 pr-4">
          <div id="s-cc-card-expiry" class="input empty md:ml-0"></div>
          <label
            for="s-cc-card-expiry"
            class="s-cc-labels month-left md:ml-0 mb-1"
            >MM/YY</label
          >
        </div>
        <div class="field cc-field-item w-10 md:w-1/6">
          <div id="s-cc-card-cvc" class="input empty"></div>
          <label for="s-cc-card-cvc" class="s-cc-labels mb-1">CVV</label>
        </div>
      </div>
    </div>
    <ValidationProvider v-slot="{ errors }" rules="required">
      <div
        v-if="stripeErrorCode || errors.length || STRIPE_ERROR_MSG"
        class="error text-xs text-error-20 md:text-sm my-1"
        role="alert"
      >
        <span class="message">{{
          stripeErrorMessage || errors[0] || STRIPE_ERROR_MSG
        }}</span>
      </div>
      <input
        type="hidden"
        vid="vid_credit_card"
        :value="ccFilled && !stripeErrorCode ? 1 : ''"
      />
      <MkInput rules="alpha_spaces" v-show="creditCardLoaded" class="mb-4 mt-4" :value="cardHolderName" variant="outline" label="Cardholder name" @input="cardHolderName = $event" />
    </ValidationProvider>
  </div>
</template>
<script>
import { loadStripe } from '@stripe/stripe-js'
import { ValidationProvider } from 'vee-validate'
import { mapState } from 'vuex'
import MKSpinnerAnimation from '~/components/D2C/atoms/MKSpinnerAnimation.vue'
import MkInput from '~/components/D2C/atoms/MkInput.vue';
let stripe
export default {
  name: 'MKStripeCC',
  components: {
    ValidationProvider,
    MKSpinnerAnimation,
    MkInput
  },
  props: {
    id: {
      type: String,
      default: null,
    },
    labelSrOnly: {
      type: Boolean,
      default: false,
    },
    helpText: {
      type: String,
      default: null,
    },
    label: {
      type: String,
      default: null,
    },
    disabled: {
      type: Boolean,
      default: false,
    },
    displayonly: {
      type: Boolean,
      default: false,
    },
    hasError: {
      type: Boolean,
      default: false,
    },
    rules: {
      type: String,
      default: null,
    },
    variant: {
      type: String,
      default: '',
    },
  },
  data() {
    return {
      errorMessages: {
        incomplete_number: 'Your card number is incomplete.',
        invalid_number: 'Please enter a valid card number.',
        incomplete_expiry: "Your card's expiration date is incomplete.",
        incomplete_cvc: "Your card's security code is incomplete.",
        invalid_expiry_year_past: 'This card has expired.',
        invalid_expiry_month_past: 'This card has expired.',
        required: 'Required',
      },
      creditCardLoaded: false,
      ccTouched: 0,
      ccNumFilled: false,
      ccExpiryFilled: false,
      ccCvvFilled: false,
      ccNumError: '',
      ccExpiryError: '',
      ccCvvError: '',
      cardHolderName:''
    }
  },
  computed: {
    stripeErrorCode() {
      return (
        this.ccNumError ||
        this.ccExpiryError ||
        this.ccCvvError ||
        this.$store.state.STRIPE_STORE.STRIPE_ERROR_CODE
      )
    },
    stripeErrorMessage() {
      return (
        (this.stripeErrorCode && this.errorMessages[this.stripeErrorCode]) || ''
      )
    },
    ccFilled() {
      return this.ccNumFilled && this.ccExpiryFilled && this.ccCvvFilled
    },
    ...mapState('STRIPE_STORE', ['CARD_ICON', 'STRIPE_ERROR_MSG']),
  },
  async mounted() {
    stripe = await loadStripe(process.env.stripe_pk)
    await this.$store.dispatch('STRIPE_STORE/CARD_ICON', { brand: 'unknown' })
    this.$store.commit('STRIPE_STORE/SET_STRIPE_ERROR_MSG')
    const elements = await stripe.elements({
      // automatically detect locale
      locale: 'auto',
    })

    const elementStyles = {
      base: {
        fontSize: '16px',
        fontFamily: 'Akkurat Pro Regular',
        iconColor: '#d7d5d4',
        color: '#000000',
        fontSmoothing: 'antialiased',
        letterSpacing: 'normal',
        lineHeight: '1.5',
        fontWeight: 300,
      },
      invalid: {
        iconColor: '#ed5d71',
        color: '#ed5d71',
        '::placeholder': {
          color: '#FFCCA5',
        },
      },
    }

    const elementClasses = {
      focus: 'focused',
      empty: 'empty',
      invalid: 'invalid',
    }

    const cardNumber = elements.create('cardNumber', {
      style: elementStyles,
      classes: elementClasses,
      showIcon: false,
    })
    cardNumber.mount('#s-cc-card-number')

    const cardExpiry = elements.create('cardExpiry', {
      style: elementStyles,
      classes: elementClasses,
    })
    cardExpiry.mount('#s-cc-card-expiry')

    const cardCvc = elements.create('cardCvc', {
      style: elementStyles,
      classes: elementClasses,
    })
    cardCvc.mount('#s-cc-card-cvc')

    // Monitor change events on the Card Element to display any errors.
    cardNumber.on('change', async (responses) => {
      await this.$store.dispatch('STRIPE_STORE/CARD_VALIDATION', responses)
      await this.$store.dispatch('STRIPE_STORE/CARD_ICON', responses)
      this.$store.commit('STRIPE_STORE/SET_STRIPE_ERROR_MSG')
      this.ccNumFilled = responses.complete
      this.ccNumError = responses.error?.code
      this.checkDetailsFilled()
    })

    cardExpiry.on('change', (responses) => {
      this.$store.dispatch('STRIPE_STORE/CARD_VALIDATION', responses)
      this.ccExpiryFilled = responses.complete
      this.ccExpiryError = responses.error?.code
      this.checkDetailsFilled()
    })

    cardCvc.on('change', (responses) => {
      this.$store.dispatch('STRIPE_STORE/CARD_VALIDATION', responses)
      this.ccCvvFilled = responses.complete
      this.ccCvvError = responses.error?.code
      this.checkDetailsFilled()
    })

    // Show the credit card form when stripe element is ready
    cardCvc.on('ready', () => {
      this.creditCardLoaded = true
    })

    window.getPaymentToken = async () => {
      return await stripe.createToken(cardNumber)
    }

    window.getPaymentIntent = async (
      clientSecret,
      stripeBillingDetails = {}
    ) => {
      const result = await stripe.confirmCardSetup(clientSecret, {
        payment_method: {
          card: cardNumber,
          billing_details: stripeBillingDetails,
        },
      })
      let id = ''
      if (result && result.setupIntent) {
        this.$store.commit('STRIPE_STORE/SET_STRIPE_ERROR_MSG')
        id = result.setupIntent.id
      }
      if (result && result.error) {
        this.$store.commit(
          'STRIPE_STORE/SET_STRIPE_ERROR_MSG',
          result.error.message
        )
      }
      return id
    }
  },
  methods: {
    checkDetailsFilled() {
      const cardDetailsFilled =
        this.ccNumFilled && this.ccExpiryFilled && this.ccCvvFilled
      this.$emit('card-filled', cardDetailsFilled)
    },
  },
}
</script>
<style scoped>
.mk-cc-input .field {
  position: relative;
  height: 50px;
  /* margin: 0 10px; */
}
.icon-margin {
  margin: 0 16px 0 0px;
}
.mk-cc-input label {
  position: absolute;
  width: 100%;
  left: 0;
  bottom: 10px;
  color: #000;
  overflow: hidden;
  text-overflow: ellipsis;
  white-space: nowrap;
  transform-origin: 0 50%;
  cursor: text;
  pointer-events: none;
  transition-property: color, transform;
  transition-duration: 0.3s;
  transition-timing-function: cubic-bezier(0.165, 0.84, 0.44, 1);
}

.mk-cc-input .month-left {
  transform: translateX(0px);
}
.mk-cc-input .number-left {
  transform: translateX(5px);
}

.mk-cc-input .input {
  position: absolute;
  width: 100%;
  left: 0;
  bottom: 8px;
  padding-bottom: 0px;
  color: #32325d;
  background-color: transparent;
  padding-left: 0;
}

.mk-cc-input .input::-webkit-input-placeholder {
  color: transparent;
  transition: color 0.3s cubic-bezier(0.165, 0.84, 0.44, 1);
}

.mk-cc-input .input::-moz-placeholder {
  color: transparent;
  transition: color 0.3s cubic-bezier(0.165, 0.84, 0.44, 1);
}

.mk-cc-input .input:-ms-input-placeholder {
  color: transparent;
  transition: color 0.3s cubic-bezier(0.165, 0.84, 0.44, 1);
}

.mk-cc-input .input.StripeElement {
  opacity: 0;
  transition: opacity 0.3s cubic-bezier(0.165, 0.84, 0.44, 1);
  will-change: opacity;
}

.mk-cc-input .input.focused,
.mk-cc-input .input:not(.empty) {
  opacity: 1;
}

.mk-cc-input .input.focused::-webkit-input-placeholder,
.mk-cc-input .input:not(.empty)::-webkit-input-placeholder {
  color: #cfd7df;
}

.mk-cc-input .input.focused::-moz-placeholder,
.mk-cc-input .input:not(.empty)::-moz-placeholder {
  color: #cfd7df;
}

.mk-cc-input .input.focused:-ms-input-placeholder,
.mk-cc-input .input:not(.empty):-ms-input-placeholder {
  color: #cfd7df;
}

.mk-cc-input .input.focused + label,
.mk-cc-input .input:not(.empty) + label {
  color: #000;
  transform: scale(0.85) translateY(-25px);
  cursor: default;
  font-size: 14px;
  line-height: 16px;
}
.mk-cc-input .input.focused + label[for='s-cc-card-number'],
.mk-cc-input .input:not(.empty) + label[for='s-cc-card-number'] {
  transform: scale(0.85) translateX(0) translateY(-25px);
}
.mk-cc-input .input.focused + label[for='s-cc-card-expiry'],
.mk-cc-input .input:not(.empty) + label[for='s-cc-card-expiry'] {
  transform: scale(0.85) translateX(0px) translateY(-25px);
}

.mk-cc-input .input.focused + label {
  color: #000;
  font-size: 14px;
  line-height: 16px;
}
.mk-cc-input .InputContainer .InputElement {
  top: 4px;
}
</style>
<style lang="scss">
.cc-input {
  @media (max-width: 900px) {
    width: 70%;
  }
  @media (max-width: 600px) {
    width: 100%;
  }
}
</style>
<style lang="postcss">
.cc-input {
  @apply mt-4 h-16;
}
.s-cc-labels {
  @apply absolute duration-300 origin-0 font-primary-font-light text-sm;
}
.mk-cc-input label {
  @apply text-base font-primary-font-light;
}
.mk-cc-input {
  @apply h-15;
}
.CardBrandIcon img {
  @apply w-9 h-6;
}
.mk-cc-input .input.focused + label,
.mk-cc-input .input:not(.empty) + label {
  @apply font-primary-font-bold;
}
.ElementsApp,
.ElementsApp .InputContainer .InputElement {
  @apply font-primary-font-bold !important;
}
</style>

<style lang="scss">
.cc-fields {
  display: flex;
  flex-wrap: nowrap;
  flex-direction: row;
  align-items: center;
}
.cc-field-item {
  flex: auto;
  margin: 10px;
  margin-left: 0;
  margin-right: 0;
}
.cc-field-number {
  /* width: 40%; */
  // @media (max-width: 768px) {
  //   width: 33%;
  // }
}
</style>
